// GrobalMain.cpp: CGrobalMain NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "inc.h"
#include "GrobalMain.h"

#include "DirectMusicSegment.h"
#include "DirectSoundBuffer.h"

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CGrobalMain::CGrobalMain()
{

}

CGrobalMain::~CGrobalMain()
{

}

void CGrobalMain::Start(HINSTANCE hi, HWND hw)
{
////////// {If[^ ///////////////////////////////
	m_hInstance = hi;
	m_hWnd = hw;

////////// gf[^ ///////////////////////////////
	ds.Initialize(m_hWnd);
	dm.Initialize(m_hWnd);
	di.Initialize(m_hInstance,m_hWnd);
	di.AcquireKey();
	dd.Initialize(m_hWnd,640,480,16);
	pbk = new CDirectDrawSurface;
	dd.GetBackSurface(pbk);

	time_t t;
	srand(time(&t));
////////// \[X[h /////////////////////////////////
	dd.CreateSurface(&m_Back,"res\\back.bmp");
	dd.CreateSurface(&m_ImageList[0],"res\\black.bmp");
	dd.CreateSurface(&m_ImageList[1],"res\\num1.bmp");
	dd.CreateSurface(&m_ImageList[2],"res\\num2.bmp");
	dd.CreateSurface(&m_ImageList[3],"res\\num3.bmp");
	dd.CreateSurface(&m_ImageList[4],"res\\num4.bmp");
	dd.CreateSurface(&m_ImageList[5],"res\\num5.bmp");
	dd.CreateSurface(&m_ImageList[6],"res\\num6.bmp");
	dd.CreateSurface(&m_ImageList[7],"res\\num7.bmp");
	dd.CreateSurface(&m_ImageList[8],"res\\era1.bmp");
	dd.CreateSurface(&m_ImageList[9],"res\\era2.bmp");
	dd.CreateSurface(&m_ImageList[10],"res\\era3.bmp");
	dd.CreateSurface(&m_ImageList[11],"res\\era4.bmp");
	dd.CreateSurface(&m_ImageList[12],"res\\era5.bmp");
	dd.CreateSurface(&m_ImageList[13],"res\\era6.bmp");
	dd.CreateSurface(&m_ImageList[14],"res\\era7.bmp");

	dm.CreateSegment(&m_Bgm,"res\\bgm.mid");
	m_Bgm.SetRepeats(2<<25);

	Sleep(1000);

// X^[g //////////////////////////////////////////////
	m_Mode = TITLE;
	StartTimer();
}

void CGrobalMain::End()
{
	EndTimer();
	delete pbk;
}

void CGrobalMain::StartTimer()
{
	timeBeginPeriod( 10 );
	m_TimerID = timeSetEvent( 50,10,MMTimerProc,(unsigned long)((void*)this),TIME_PERIODIC );
//	m_TimerID = 178116;
//	SetTimer(m_hWnd, m_TimerID, 50, NULL);
}

void CGrobalMain::EndTimer()
{
	timeKillEvent( m_TimerID );
	timeEndPeriod( 10 );
//	KillTimer( m_hWnd , m_TimerID );
}

void CALLBACK CGrobalMain::MMTimerProc( UINT uID , UINT uMsg , DWORD dwUser , DWORD dw1 , DWORD dw2 )
{
	CGrobalMain* p = (CGrobalMain*)dwUser;
	PostMessage( p->m_hWnd,BNM_MMTIMER,uID,NULL );
}

void CGrobalMain::Activate(BOOL bActive)
{
	if( bActive && !m_bActive )
	{
		SetCursor(NULL);
		m_bActive = true;
		dd.RestoreAll();
		StartTimer();
	}
	else if( !bActive && m_bActive )
	{
		m_bActive = false;
		EndTimer();
	}
}

void CGrobalMain::Timer(UINT ID)
{
	if(!m_bActive)
		return;

	if( di.IsKeyDown(DIK_ESCAPE) )
	{
		PostQuitMessage(0);
		return;
	}

	switch( m_Mode )
	{
	case TITLE:		m_Mode=BATTLE;	m_ModeDetail=INIT;	break;
	case BATTLE:	BattleProc();	break;
	case DEADEND:
		{
			char key[256];
			di.GetKeyState(256,key);
			if( key[DIK_S]!=0 )
				m_Mode=TITLE;
			break;
		}
	default:	PostQuitMessage(0);	break;
	}
}

void CGrobalMain::BattleProc()
{
	switch( m_ModeDetail )
	{
	case INIT:
		m_CurBlock.Remake();
		m_Field.Init();
		m_ModeDetail=FALL;
		memset(m_LastKey,0,256);
		m_Rensa=0;
		dm.PlaySegment(&m_Bgm);
		break;

	case FALL:
		{
			m_CurBlock.Down(0.1);
			if( m_Field.Overlap(&m_CurBlock) )
			{
				m_CurBlock.Down(-0.1);
				m_Field.SetBlock(&m_CurBlock);
				m_ModeDetail = JUDGE_B;
			}
			else
			{
				char key[256];
				di.GetKeyState(256,key);

				// Rotate&Slide
				if( key[DIK_A]!=0 && m_LastKey[DIK_A]==0 )
				{
					m_CurBlock.Slide(-1);
					if( m_Field.Overlap(&m_CurBlock) )
						m_CurBlock.Slide(1);
				}
				else if( key[DIK_D]!=0 && m_LastKey[DIK_D]==0 )
				{
					m_CurBlock.Slide(1);
					if( m_Field.Overlap(&m_CurBlock) )
						m_CurBlock.Slide(-1);
				}
				else if( key[DIK_S]!=0 && m_LastKey[DIK_S]==0 )
				{
					m_CurBlock.Rotate(3);
					if( m_Field.Overlap(&m_CurBlock) )
						m_CurBlock.Rotate(1);
				}
				else if( key[DIK_X]!=0 && m_LastKey[DIK_X]==0 )
				{
					m_Field.SetBlock(&m_CurBlock);
					m_ModeDetail = JUDGE_B;
				}

				memcpy(m_LastKey,key,256);
			}
			break;
		}

	case JUDGE_B://BreakiAj
		m_Field.Break();
		m_ModeDetail=JUDGE_ES;
		break;

	case JUDGE_ES://Erase_Search
		if( m_Field.EraseSearch() )
		{
			m_Rensa++;
			m_ModeDetail=JUDGE_EW;
		}
		else
		{
			if( m_Field.IsDead() )
				m_Mode=DEADEND;
			else
			{
				m_Rensa=0;
				m_CurBlock.Remake();
				m_ModeDetail=FALL;
			}
		}
		break;
	case JUDGE_EW://Erase_Wait
		Sleep(300);
		m_ModeDetail=JUDGE_ER;
		break;
	case JUDGE_ER://Erase
		m_Field.Erase(m_Rensa);
		m_ModeDetail=JUDGE_B;
		break;

	default:
		PostQuitMessage(0);	break;
	}

	pbk->Blt(NULL,&m_Back,NULL,DDBLT_WAIT,NULL);
	m_Field.Draw(pbk);
	if( m_ModeDetail==FALL )
		m_Field.DrawBlock(&m_CurBlock,pbk);

	if( m_Mode==DEADEND )
		m_Field.DrawScore(pbk);

	dd.Flip();
}

